# -*- coding: utf-8 -*-

import time
import datetime
import socket
import random
import cv2
import serial
import numpy as np
import threading
import logging

class AutoPlayer(threading.Thread):
	def __init__(self):
		super(AutoPlayer, self).__init__()
		
		self.cap = Capture()
		self.ser = Serial()
		
		self.charas=[]
		self.charas.append('kasumi')
		self.charas.append('momizi')
		self.charas.append('leifang')
		self.charas.append('hitomi')
		self.charas.append('erena')
		self.charas.append('marie')
		self.charas.append('honoka')
		self.charas.append('nyotengu')
		self.charas.append('misaki')
		self.charas.append('kokoro')
		self.charas.append('ayane')
		
		self.chara='kokoro'
		self.skipChara = []
		self.charaLoopTimes = 1
		self.charaLoopCount = 1
		log.setChara(self.chara)
		log.setLoopCount(self.charaLoopCount)
		self.autoPlayState = "START"
	
	def pause(self):
		self.autoPlayState = "PAUSE"
		
	def resume(self):
		self.autoPlayState = "START"
		
	def stop(self):
		self.autoPlayState = "STOP"
		
	def doGame(self):
		log.myPrint('  Do Game')
		self.ser.pressKey('Button A')
		time.sleep(3)
		while not self.cap.capIs(["now_loading.png", "day_time.png", "evening.png", "night_time.png"]):
			self.ser.pressKey('Button A')
			time.sleep(0.1)
		time.sleep(10)

	def goToBed(self):
		log.myPrint('  Go To Bed')
		isLastNight = False
		while not self.cap.capIs('hotel_sleep.png'):
			self.skipSpeech()
			self.ser.pressKey('HAT BOTTOM')
			time.sleep(0.5)
			if self.cap.capIs('last_night.png'):
				isLastNight = True
				break
		self.ser.pressKey('Button A')
		time.sleep(5)
		self.skipSpeech()
		if isLastNight:
			self.skipMovie()
			self.skipSpeech()

	def skipSpeech(self):
		if self.cap.capIs(['skip_speech.png', 'next1.png', 'next2.png', 'go_title.png']):
			log.myPrint(' Skip Speech')
			while self.cap.capIs(['skip_speech.png', 'next1.png', 'next2.png', 'go_title.png']):
				self.ser.pressKey('Button A')
				time.sleep(3)
		
	def skipMovie(self):
		log.myPrint(' Skip Movie')
		time.sleep(5)
		self.ser.pressKey('Button B')
		time.sleep(1)
		self.ser.pressKey('Button START')
		time.sleep(5)

	def myPrint(self, *printStrList):
		dt_now = datetime.datetime.now()
		msg = '['+dt_now.strftime('%Y-%m-%d %H:%M:%S')+'] '
		msg = msg+'['+self.chara+'] '
		for printStr in printStrList:
			msg = msg+str(printStr)
		print(msg)
	
	def run(self):				
		loopCount=0
		notDetectCount=0
		
		while self.autoPlayState in ["START", "PAUSE"]:
			while self.autoPlayState is "PAUSE":
				time.sleep(1)
				
			self.skipSpeech()
			
			if self.cap.capIs(["morning.png", "day_time.png", "evening.png"]):
				if self.cap.capIs("in_pool.png"):
					keyCount=0
					key='HAT BOTTOM'
					while not self.cap.capIs("donketsu_select.png"):
						self.ser.pressKey(key)
						time.sleep(0.5)
						keyCount=keyCount+1
						if keyCount>5:
							if key=='HAT BOTTOM':
								key='HAT TOP'
							else:
								key='HAT BOTTOM'
							keyCount=0
					self.ser.pressKey('Button A')
					time.sleep(5)
					self.doGame()
				else:
					self.ser.pressKey('Button B')
					log.myPrint(' Select Pool')
					while not self.cap.capIs('location_pool.png'):
						self.ser.pressKey('HAT RIGHT')
						time.sleep(0.5)
					self.ser.pressKey('Button A')
					time.sleep(3)
			elif self.cap.capIs(["night_time.png", "in_hotel.png"]):
				self.goToBed()
			elif self.cap.capIs("in_casino.png"):
				self.ser.pressKey('Button B')
			elif self.cap.capIs("ending_logo.png"):
				self.skipMovie()
			elif self.cap.capIs("title_logo.png"):
				time.sleep(1)
				self.ser.pressKey('Button B')
				time.sleep(2)
				while not self.cap.capIs('go_island.png'):
					self.ser.pressKey('HAT BOTTOM')
					time.sleep(1)
				self.ser.pressKey('Button A')
				time.sleep(5)
				self.skipMovie()
			elif self.cap.capIs("select_girl.png"):
				if self.charaLoopTimes <= self.charaLoopCount:
					charaNum = self.charas.index(self.chara)
					nextCharaNum = (charaNum+1)%len(self.charas)
					nextChara = self.charas[nextCharaNum]
					while nextChara in self.skipChara:
						nextCharaNum = (nextCharaNum+1)%len(self.charas)
						nextChara = self.charas[nextCharaNum]
					self.chara = nextChara
					log.setChara(self.chara)
					self.charaLoopCount = 0
				self.charaLoopCount += 1
				log.setLoopCount(self.charaLoopCount)
				log.myPrint(' Select: '+self.chara)
				while not self.cap.capIs('chara\\'+self.chara+'.png'):
					self.ser.pressKey('HAT RIGHT')
					time.sleep(1)
				self.ser.pressKey('Button A')
				time.sleep(3)
				self.skipMovie()
			elif self.cap.capIs("select_partner.png"):
				self.ser.pressKey('Button A')
				time.sleep(5)
			else:
				log.myPrint('Can\'t detect item.')
				self.ser.pressKey('HAT BOTTOM')
				time.sleep(1)
		
		#self.cap.closeCamera()
		self.ser.closeSerial()
		

class Serial:
	def openSerial(self, portNum):
		self.ser = serial.Serial(portNum, 9600)
		self.ser.write(b'RELEASE\r\n')
		
	def closeSerial(self):
		self.ser.close()
	
	def pressKey(self, key):
		self.ser.write((key+'\r\n').encode('utf-8'))
		time.sleep(0.1)
		self.ser.write(b'RELEASE\r\n')
		
class Capture:
	def __init__(self):
		self.nextCapture = None
	
	def openCamera(self, cameraId):
		if __name__ == "__main__":
			self.camera = cv2.VideoCapture(cameraId)
	
	def closeCamera(self):
		if __name__ == "__main__":
			self.camera.release()
		
	def takeCapture(self):
		if __name__ == "__main__":
			_, self.capture = self.camera.read()
		else:
			while self.nextCapture is None:
				pass
			self.capture = self.nextCapture
		
	def setCapture(self, image):
		self.nextCapture = image
				
	def capIs(self, imgFileList):
		self.takeCapture()
		threshold= 0.7
		npimg = np.asarray(self.capture)
		capimg = cv2.cvtColor(npimg,cv2.COLOR_BGR2GRAY)
		
		if type(imgFileList) is not list:
			imgFileList = [imgFileList]
		
		imgIsDetectList = []
		for imgFile in imgFileList:
			patimg = cv2.imread('img\\'+imgFile,0)
			#patimg = cv2.resize(patimg,(int(len(patimg[0])*windowScale),int(len(patimg)*windowScale)))
			w, h = patimg.shape[::-1]
			
			npimg = np.asarray(self.capture)
			npimg = cv2.cvtColor(npimg,cv2.COLOR_BGR2GRAY)
			
			method = cv2.TM_CCOEFF_NORMED
			res = cv2.matchTemplate(npimg,patimg,method)
			min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(res)
			
			top_left = max_loc
			bottom_right = (top_left[0] + w, top_left[1] + h)

			cv2.rectangle(npimg,top_left, bottom_right, 255, 2)
			retXY = [top_left[0] + w/2, top_left[1] + h/2],
			#print(max_val)
			
			if max_val > threshold:
				imgIsDetectList.append(True)
			else:
				imgIsDetectList.append(False)
			
		if True in imgIsDetectList:
			log.myPrint('Detect '+imgFileList[imgIsDetectList.index(True)])
			return True
		else:
			return False
			
	def myPrint(self, *printStrList):
		dt_now = datetime.datetime.now()
		msg = '['+dt_now.strftime('%Y-%m-%d %H:%M:%S')+'] '
		for printStr in printStrList:
			msg = msg+str(printStr)
		print(msg)

class Log:
	def setChara(self, chara):
		self.chara = chara
	
	def setLoopCount(self, loopCount):
		self.loopCount = loopCount

	def myPrint(self, *printStrList):
		dt_now = datetime.datetime.now()
		msg = '['+dt_now.strftime('%Y-%m-%d %H:%M:%S')+']'
		msg = msg+'['+self.chara+','+str(self.loopCount)+'] '
		for printStr in printStrList:
			msg = msg+str(printStr)
		print(msg)

log = Log()
if __name__ == "__main__":
	autoPlayer = AutoPlayer()
	autoPlayer.cap.openCamera(1)
	autoPlayer.ser.openSerial("COM8")
	autoPlayer.start()
	autoPlayer.stop()